## sunxi-tools 1.2

=== debian/changelog ===
sunxi-tools (1.2-2) unstable; urgency=medium

  * Create a "sunxi-fel" group and add udev rules to make the FEL mode USB
    device available to members of that group.
  * Include upstream README in the package (Closes: #757642)

 -- Ian Campbell <ijc@hellion.org.uk>  Mon, 25 Aug 2014 21:40:38 +0100

sunxi-tools (1.2-1) unstable; urgency=medium

  * Initial release (Closes: #750104).

 -- Ian Campbell <ijc@hellion.org.uk>  Sat, 12 Jul 2014 20:51:56 +0100
