=== debian/changelog ===
sunxi-tools (1.3-1) unstable; urgency=medium

  * New upstream release.
    - Support for new "spl" sub command to the fel tool.
    - Various bug fixes.
  * Update Vcs-* to point to anonscm.
  * Recommend split u-boot-sunxi package only.

 -- Ian Campbell <ijc@debian.org>  Tue, 24 Nov 2015 20:27:33 +0000
