=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f bin/fel-pio.* bin/*.sunxi bin/*.scr
	if [ -f fel-to-spl-thunk.h.pristine ] ; then \
		mv fel-to-spl-thunk.h.pristine fel-to-spl-thunk.h ; \
	fi

override_dh_auto_build:
	if [ ! -f fel-to-spl-thunk.h.pristine ] ; then \
		cp fel-to-spl-thunk.h fel-to-spl-thunk.h.pristine ; \
	fi
	ruby -x fel-to-spl-thunk.S > fel-to-spl-thunk.h

	$(MAKE) tools
ifneq ($(filter armel armhf arm64,$(DEB_HOST_ARCH)),)
	$(MAKE) target-tools
endif
	mkimage -A arm -T script -d bin/ramboot.uboot-sh bin/ramboot.scr

override_dh_auto_install: PKG := debian/sunxi-tools
override_dh_auto_install:
	$(MAKE) install-tools DESTDIR=$(CURDIR)/$(PKG) PREFIX=/usr
ifneq ($(filter armel armhf arm64,$(DEB_HOST_ARCH)),)
	$(MAKE) install-target-tools DESTDIR=$(CURDIR)/$(PKG) PREFIX=/usr
endif

	install -m0644 bin/ramboot.scr $(PKG)/usr/share/sunxi-tools/ramboot.scr
