=== debian/changelog ===
sunxi-tools (1.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Update standard version, no changes required.
  * Enable hardening flags.

 -- Ian Campbell <ijc@debian.org>  Sun, 30 Oct 2016 13:36:07 +0000
