=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ian Campbell <ijc@debian.org>
 Build-Depends: debhelper (>= 9), pkg-config, libusb-1.0-0-dev, u-boot-tools,
   ruby, binutils-arm-none-eabi
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Vcs-Git: git://anonscm.debian.org/collab-maint/sunxi-tools.git
 Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/sunxi-tools.git
 Homepage: http://linux-sunxi.org/Sunxi-tools
