=== debian/rules ===
--- 
+++ 
@@ -22,17 +22,11 @@
 	fi
 	ruby -x fel-to-spl-thunk.S > fel-to-spl-thunk.h
 
-	$(MAKE) tools
-ifneq ($(filter armel armhf arm64,$(DEB_HOST_ARCH)),)
-	$(MAKE) target-tools
-endif
+	$(MAKE) EXTRA_CFLAGS="$(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" tools
 	mkimage -A arm -T script -d bin/ramboot.uboot-sh bin/ramboot.scr
 
 override_dh_auto_install: PKG := debian/sunxi-tools
 override_dh_auto_install:
 	$(MAKE) install-tools DESTDIR=$(CURDIR)/$(PKG) PREFIX=/usr
-ifneq ($(filter armel armhf arm64,$(DEB_HOST_ARCH)),)
-	$(MAKE) install-target-tools DESTDIR=$(CURDIR)/$(PKG) PREFIX=/usr
-endif
 
 	install -m0644 bin/ramboot.scr $(PKG)/usr/share/sunxi-tools/ramboot.scr
