## sunxi-tools 1.4.2~git20181114.6d598a

=== debian/changelog ===
sunxi-tools (1.4.2~git20181114.6d598a-1) unstable; urgency=medium

  [ Ian Campbell ]
  * New upstream snapshot.
    - Updated d/copyright
    - Added build-dep on zlib
  * Update Standards-Version, no changes required.
  * Add lintian override for AppStream warning
  * Disable "check_all_fex" test target since it requires external resources.

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

 -- Ian Campbell <ijc@debian.org>  Sat, 15 Dec 2018 21:00:47 +0000

sunxi-tools (1.4.1-2) unstable; urgency=medium

  * Regularise and update debian/{control,copyright} using CME.
  * Update VCS-* to point to salsa.
  * Update Standards-Version, no changes required.
  * Correct udev rule to use SUBSYSTEM not (unnecessarily) SUBSYSTEMS.

 -- Ian Campbell <ijc@debian.org>  Sun, 13 May 2018 14:15:12 +0100
