=== debian/control ===
Source: sunxi-tools
Maintainer: Ian Campbell <ijc@debian.org>
Section: utils
Priority: optional
Build-Depends: debhelper (>= 9),
               pkg-config,
               libusb-1.0-0-dev,
               u-boot-tools,
               ruby,
               binutils-arm-none-eabi,
               zlib1g-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian/sunxi-tools
Vcs-Git: https://salsa.debian.org/debian/sunxi-tools.git
Homepage: http://linux-sunxi.org/Sunxi-tools

Package: sunxi-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: u-boot-sunxi:armhf
Description: tools for working with Allwinner (sunxi) ARM processors
 This package contains various tools for working with devices based around the
 Allwinner sunxi processors (A10/A13/A20/A31 etc). Utilities include tools to:
 .
  - interact with the processors' lowlevel bootrom (AKA FEL mode).
  - boot over the USB OTG port.
  - compile and decompile the Allwinner binary hardware descriptions (FEX
    files).
  - display information about sunxi boot headers.
