=== debian/rules ===
--- 
+++ 
@@ -12,16 +12,9 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -f bin/fel-pio.* bin/*.sunxi bin/*.scr
-	if [ -f fel-to-spl-thunk.h.pristine ] ; then \
-		mv fel-to-spl-thunk.h.pristine fel-to-spl-thunk.h ; \
-	fi
 
 override_dh_auto_build:
-	if [ ! -f fel-to-spl-thunk.h.pristine ] ; then \
-		cp fel-to-spl-thunk.h fel-to-spl-thunk.h.pristine ; \
-	fi
-	ruby -x fel-to-spl-thunk.S > fel-to-spl-thunk.h
-
+	$(MAKE) -C thunks CROSS_COMPILE=arm-none-eabi-
 	$(MAKE) EXTRA_CFLAGS="$(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" tools
 	mkimage -A arm -T script -d bin/ramboot.uboot-sh bin/ramboot.scr
