=== debian/changelog ===
sunxi-tools (1.4.2+git20181114.6d598a-3) unstable; urgency=medium

  * Only trigger a udev event if `udevadm` is available. Discovered by
    piuparts. Also ignore any error from `udevadm trigger`. (Closes: #918465).

 -- Ian Campbell <ijc@debian.org>  Sun, 06 Jan 2019 12:14:53 +0000

sunxi-tools (1.4.2+git20181114.6d598a-2) unstable; urgency=medium

  * Bump Standards-Version to 4.3.0, no changes required.
  * Switch to debhelper compat level 12, using the new debhelper-compat
    dependency instead of debian/compat. No other changes required.
  * Specify Rules-Requires-Root: no.
  * Update Lintian overrides.
  * Trigger a udev event on the USB device in postinst, to cause the group
    ownership set by a newly installed udev rules file to take effect
    immediately.

 -- Ian Campbell <ijc@debian.org>  Sat, 05 Jan 2019 12:07:16 +0000

sunxi-tools (1.4.2+git20181114.6d598a-1) unstable; urgency=medium

  * Correct versioning of upstream snapshot (~git is before 1.4.2, while +git
    is after which is what was intended).
  * Ensure hardened CFLAGS/CPPFLAGS are propagated to the build, this changed
    in the git20181114.6d598a snapshot.

 -- Ian Campbell <ijc@debian.org>  Sun, 16 Dec 2018 15:02:19 +0000
