=== debian/control ===
--- 
+++ 
@@ -2,17 +2,18 @@
 Maintainer: Ian Campbell <ijc@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 12),
                pkg-config,
                libusb-1.0-0-dev,
                u-boot-tools,
                ruby,
                binutils-arm-none-eabi,
                zlib1g-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian/sunxi-tools
 Vcs-Git: https://salsa.debian.org/debian/sunxi-tools.git
 Homepage: http://linux-sunxi.org/Sunxi-tools
+Rules-Requires-Root: no
 
 Package: sunxi-tools
 Architecture: any
