=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 override_dh_auto_build:
 	$(MAKE) -C thunks CROSS_COMPILE=arm-none-eabi-
-	$(MAKE) EXTRA_CFLAGS="$(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" tools
+	$(MAKE) CFLAGS="$(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" tools
 	mkimage -A arm -T script -d bin/ramboot.uboot-sh bin/ramboot.scr
 
 override_dh_auto_install: PKG := debian/sunxi-tools
