## sunxi-tools 1.4.2+git20220212.08e209

=== Makefile ===
--- 
+++ 
@@ -36,6 +36,8 @@
 
 DEFAULT_CFLAGS += -Iinclude/
 
+PKG_CONFIG ?= pkg-config
+
 # Tools useful on host and target
 TOOLS = sunxi-fexc sunxi-bootinfo sunxi-fel sunxi-nand-part sunxi-pio
 
@@ -62,6 +64,7 @@
 DESTDIR ?=
 PREFIX  ?= /usr/local
 BINDIR  ?= $(PREFIX)/bin
+MANDIR  ?= $(PREFIX)/share/man/man1
 
 .PHONY: all clean tools target-tools install install-tools install-target-tools
 .PHONY: check
@@ -86,6 +89,7 @@
 	@set -ex ; for l in $(FEXC_LINKS) ; do \
 		ln -nfs sunxi-fexc $(DESTDIR)$(BINDIR)/$$l ; \
 	done
+	install -D -m0644 -t $(DESTDIR)$(MANDIR) sunxi-fel.1
 
 install-target-tools: $(TARGET_TOOLS)
 	install -d $(DESTDIR)$(BINDIR)
@@ -116,12 +120,12 @@
 	script_fex.h script_fex.c
 
 LIBUSB = libusb-1.0
-LIBUSB_CFLAGS ?= `pkg-config --cflags $(LIBUSB)`
-LIBUSB_LIBS ?= `pkg-config --libs $(LIBUSB)`
+LIBUSB_CFLAGS ?= `$(PKG_CONFIG) --cflags $(LIBUSB)`
+LIBUSB_LIBS ?= `$(PKG_CONFIG) --libs $(LIBUSB)`
 
 ZLIB = zlib
-ZLIB_CFLAGS ?= `pkg-config --cflags $(ZLIB)`
-ZLIB_LIBS ?= `pkg-config --libs $(ZLIB)`
+ZLIB_CFLAGS ?= `$(PKG_CONFIG) --cflags $(ZLIB)`
+ZLIB_LIBS ?= `$(PKG_CONFIG) --libs $(ZLIB)`
 
 ifeq ($(OS),Windows_NT)
 	# Windows lacks mman.h / mmap()
