## sunxi-tools 1.4.2+git20221128.530adf

=== tests/Makefile ===
--- 
+++ 
@@ -1,6 +1,20 @@
 #
 # tests/Makefile
 #
+# Copyright (C) 2016  Bernhard Nortmann <bernhard.nortmann@web.de>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 BOARDS_URL := https://github.com/linux-sunxi/sunxi-boards/archive/master.zip
 BOARDS_DIR := sunxi-boards
